b2dde6f01cd4ae59e9fcca688bed0940934a42f7
[openwrt/staging/jow.git] / package / base-files / files / sbin / wifi
1 #!/bin/sh
2 # Copyright (C) 2006 OpenWrt.org
3
4 . /lib/functions.sh
5 . /usr/share/libubox/jshn.sh
6
7 usage() {
8 cat <<EOF
9 Usage: $0 [config|up|down|reconf|reload|status]
10 enables (default), disables or configures devices not yet configured.
11 EOF
12 exit 1
13 }
14
15 ubus_wifi_cmd() {
16 local cmd="$1"
17 local dev="$2"
18
19 json_init
20 [ -n "$2" ] && json_add_string device "$2"
21 ubus call network.wireless "$1" "$(json_dump)"
22 }
23
24 find_net_config() {(
25 local vif="$1"
26 local cfg
27 local ifname
28
29 config_get cfg "$vif" network
30
31 [ -z "$cfg" ] && {
32 include /lib/network
33 scan_interfaces
34
35 config_get ifname "$vif" ifname
36
37 cfg="$(find_config "$ifname")"
38 }
39 [ -z "$cfg" ] && return 0
40 echo "$cfg"
41 )}
42
43
44 bridge_interface() {(
45 local cfg="$1"
46 [ -z "$cfg" ] && return 0
47
48 include /lib/network
49 scan_interfaces
50
51 for cfg in $cfg; do
52 config_get iftype "$cfg" type
53 [ "$iftype" = bridge ] && config_get "$cfg" ifname
54 prepare_interface_bridge "$cfg"
55 return $?
56 done
57 )}
58
59 prepare_key_wep() {
60 local key="$1"
61 local hex=1
62
63 echo -n "$key" | grep -qE "[^a-fA-F0-9]" && hex=0
64 [ "${#key}" -eq 10 -a $hex -eq 1 ] || \
65 [ "${#key}" -eq 26 -a $hex -eq 1 ] || {
66 [ "${key:0:2}" = "s:" ] && key="${key#s:}"
67 key="$(echo -n "$key" | hexdump -ve '1/1 "%02x" ""')"
68 }
69 echo "$key"
70 }
71
72 wifi_fixup_hwmode() {
73 local device="$1"
74 local default="$2"
75 local hwmode hwmode_11n
76
77 config_get channel "$device" channel
78 config_get hwmode "$device" hwmode
79 case "$hwmode" in
80 11bg) hwmode=bg;;
81 11a) hwmode=a;;
82 11ad) hwmode=ad;;
83 11b) hwmode=b;;
84 11g) hwmode=g;;
85 11n*)
86 hwmode_11n="${hwmode##11n}"
87 case "$hwmode_11n" in
88 a|g) ;;
89 default) hwmode_11n="$default"
90 esac
91 config_set "$device" hwmode_11n "$hwmode_11n"
92 ;;
93 *)
94 hwmode=
95 if [ "${channel:-0}" -gt 0 ]; then
96 if [ "${channel:-0}" -gt 14 ]; then
97 hwmode=a
98 else
99 hwmode=g
100 fi
101 else
102 hwmode="$default"
103 fi
104 ;;
105 esac
106 config_set "$device" hwmode "$hwmode"
107 }
108
109 _wifi_updown() {
110 for device in ${2:-$DEVICES}; do (
111 config_get disabled "$device" disabled
112 [ "$disabled" = "1" ] && {
113 echo "'$device' is disabled"
114 set disable
115 }
116 config_get iftype "$device" type
117 if eval "type ${1}_$iftype" 2>/dev/null >/dev/null; then
118 eval "scan_$iftype '$device'"
119 eval "${1}_$iftype '$device'" || echo "$device($iftype): ${1} failed"
120 elif [ ! -f /lib/netifd/wireless/$iftype.sh ]; then
121 echo "$device($iftype): Interface type not supported"
122 fi
123 ); done
124 }
125
126 wifi_updown() {
127 cmd=down
128 [ enable = "$1" ] && {
129 _wifi_updown disable "$2"
130 ubus_wifi_cmd "$cmd" "$2"
131 scan_wifi
132 cmd=up
133 ubus call network reload
134 }
135 [ reconf = "$1" ] && {
136 scan_wifi
137 cmd=reconf
138 }
139 ubus_wifi_cmd "$cmd" "$2"
140 _wifi_updown "$@"
141 }
142
143 wifi_reload_legacy() {
144 _wifi_updown "disable" "$1"
145 scan_wifi
146 _wifi_updown "enable" "$1"
147 }
148
149 wifi_reload() {
150 ubus call network reload
151 wifi_reload_legacy
152 }
153
154 wifi_detect_notice() {
155 >&2 echo "WARNING: Wifi detect is deprecated. Use wifi config instead"
156 >&2 echo "For more information, see commit 5f8f8a366136a07df661e31decce2458357c167a"
157 exit 1
158 }
159
160 wifi_config() {
161 [ ! -f /etc/config/wireless ] && touch /etc/config/wireless
162
163 for driver in $DRIVERS; do (
164 if eval "type detect_$driver" 2>/dev/null >/dev/null; then
165 eval "detect_$driver" || echo "$driver: Detect failed" >&2
166 else
167 echo "$driver: Hardware detection not supported" >&2
168 fi
169 ); done
170 }
171
172 start_net() {(
173 local iface="$1"
174 local config="$2"
175 local vifmac="$3"
176
177 [ -f "/var/run/$iface.pid" ] && kill "$(cat /var/run/${iface}.pid)" 2>/dev/null
178 [ -z "$config" ] || {
179 include /lib/network
180 scan_interfaces
181 for config in $config; do
182 setup_interface "$iface" "$config" "" "$vifmac"
183 done
184 }
185 )}
186
187 set_wifi_up() {
188 local cfg="$1"
189 local ifname="$2"
190 uci_set_state wireless "$cfg" up 1
191 uci_set_state wireless "$cfg" ifname "$ifname"
192 }
193
194 set_wifi_down() {
195 local cfg="$1"
196 local vifs vif vifstr
197
198 [ -f "/var/run/wifi-${cfg}.pid" ] &&
199 kill "$(cat "/var/run/wifi-${cfg}.pid")" 2>/dev/null
200 uci_revert_state wireless "$cfg"
201 config_get vifs "$cfg" vifs
202 for vif in $vifs; do
203 uci_revert_state wireless "$vif"
204 done
205 }
206
207 scan_wifi() {
208 local cfgfile="$1"
209 DEVICES=
210 config_cb() {
211 local type="$1"
212 local section="$2"
213
214 # section start
215 case "$type" in
216 wifi-device)
217 append DEVICES "$section"
218 config_set "$section" vifs ""
219 config_set "$section" ht_capab ""
220 ;;
221 esac
222
223 # section end
224 config_get TYPE "$CONFIG_SECTION" TYPE
225 case "$TYPE" in
226 wifi-iface)
227 config_get device "$CONFIG_SECTION" device
228 config_get vifs "$device" vifs
229 append vifs "$CONFIG_SECTION"
230 config_set "$device" vifs "$vifs"
231 ;;
232 esac
233 }
234 config_load "${cfgfile:-wireless}"
235 }
236
237 DEVICES=
238 DRIVERS=
239 include /lib/wifi
240 scan_wifi
241
242 case "$1" in
243 down) wifi_updown "disable" "$2";;
244 detect) wifi_detect_notice ;;
245 config) wifi_config ;;
246 status) ubus_wifi_cmd "status" "$2";;
247 reload) wifi_reload "$2";;
248 reload_legacy) wifi_reload_legacy "$2";;
249 --help|help) usage;;
250 reconf) ubus call network reload; wifi_updown "reconf" "$2";;
251 ''|up) wifi_updown "enable" "$2";;
252 *) usage; exit 1;;
253 esac